/*
<EtherDogs is a Simple Multi Protocol Packet Sniffer>
Copyright © <2012-2013> <EtherDogs Development Team>

This file is part of EtherDogs.

    EtherDogs is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    EtherDogs is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with EtherDogs. If not, see <http://www.gnu.org/licenses/>.
*/

#include "common.h"

void print_icmp_packet(const u_char * Buffer , int Size, const char * chkip)
{
	unsigned short iphdrlen;
	
	struct iphdr *iph = (struct iphdr *)(Buffer  + sizeof(struct ethhdr));
	iphdrlen = iph->ihl * 4;
	
	struct icmphdr *icmph = (struct icmphdr *)(Buffer + iphdrlen  + sizeof(struct ethhdr));
	
	int header_size =  sizeof(struct ethhdr) + iphdrlen + sizeof icmph;

	if(check_packet(Buffer, Size, chkip)==1)
	{

	fprintf(dogslog , "\n\n***********************ICMP Packet*************************\n");	
	
	print_ip_header(Buffer , Size);
			
	fprintf(dogslog , "\n");
		
	fprintf(dogslog , "ICMP Header\n");
	fprintf(dogslog , "   |-Type : %d",(unsigned int)(icmph->type));
			
	if((unsigned int)(icmph->type) == 11)
	{
		fprintf(dogslog , "  (TTL Expired)\n");
	}
	else if((unsigned int)(icmph->type) == ICMP_ECHOREPLY)
	{
		fprintf(dogslog , "  (ICMP Echo Reply)\n");
	}
	
	fprintf(dogslog , "   |-Code : %d\n",(unsigned int)(icmph->code));
	fprintf(dogslog , "   |-Checksum : %d\n",ntohs(icmph->checksum));
	//fprintf(dogslog , "   |-ID       : %d\n",ntohs(icmph->id));
	//fprintf(dogslog , "   |-Sequence : %d\n",ntohs(icmph->sequence));
	fprintf(dogslog, "\n");

	fprintf(dogslog , "IP Header\n");
	PrintData(Buffer,iphdrlen);
		
	fprintf(dogslog , "UDP Header\n");
	PrintData(Buffer + iphdrlen , sizeof icmph);
		
	fprintf(dogslog , "Data Payload\n");	
	
	//Move the pointer ahead and reduce the size of string
	PrintData(Buffer + header_size , (Size - header_size) );
	
	fprintf(dogslog , "\n###########################################################");

	}
}

